## geany-plugins 1.23+dfsg

=== wscript ===
# -*- coding: utf-8 -*-
#
# WAF build script for geany-plugins
#
# Copyright 2008-2010 Enrico Tröger <enrico(dot)troeger(at)uvena(dot)de>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# $Id$

"""
Waf build script for Geany Plugins.

If you want to add your plugin to this build system, simply put a file called
'wscript_build' into your plugin directory and add necessary code to build your
plugin or simply copy the wscript_build file from another plugin
and adjust the values.
If special configuration is necessary, e.g. checking for dependencies of
the plugin, create a file 'wscript_configure' and put the code into.


The code of this file itself loosely follows PEP 8 with some exceptions
(line width 100 characters and some other minor things).

Requires WAF 1.6.1 and Python 2.5 (or later).
"""

import os
import tempfile
from glob import glob
from waflib import Logs, Scripting, Utils
from waflib.Tools import c_preproc
from waflib.Errors import ConfigurationError
from waflib.TaskGen import feature
from build.wafutils import (
    add_define_to_env,
    add_to_env_and_define,
    check_cfg_cached,
    get_plugins,
    get_enabled_plugins,
    get_svn_rev,
    install_docs,
    launch,
    load_intltool_if_available,
    set_lib_dir,
    setup_makefile,
    target_is_win32)


APPNAME = 'geany-plugins'
VERSION = '1.23'
LINGUAS_FILE = 'po/LINGUAS'

top = '.'
out = '_build_'


c_preproc.go_absolute = True
c_preproc.standard_includes = []


def configure(conf):

    conf.check_waf_version(mini='1.6.1')

    # a C compiler is the very minimum we need
    conf.load('compiler_c')

    # common for all plugins
    check_cfg_cached(conf,
                   package='gtk+-2.0',
                   atleast_version='2.16.0',
                   uselib_store='GTK',
                   mandatory=True,
                   args='--cflags --libs')
    check_cfg_cached(conf,
                   package='geany',
                   atleast_version='1.23',
                   uselib_store='GEANY',
                   mandatory=True,
                   args='--cflags --libs')

    set_lib_dir(conf)
    # SVN/GIT detection
    svn_rev = get_svn_rev(conf)
    conf.define('REVISION', svn_rev, 1)
    # GTK/Geany versions
    geany_version = conf.check_cfg(modversion='geany') or 'Unknown'
    gtk_version = conf.check_cfg(modversion='gtk+-2.0') or 'Unknown'

    load_intltool_if_available(conf)

    # build plugin list
    enabled_plugins = get_enabled_plugins(conf)

    # execute plugin specific coniguration code
    configure_plugins(conf, enabled_plugins)
    # now add the enabled_plugins to the env to remember them
    conf.env.append_value('enabled_plugins', enabled_plugins)

    setup_configuration_env(conf)
    setup_makefile(conf)
    conf.write_config_header('config.h')

    # enable debug when compiling from VCS
    if svn_rev > 0:
        conf.env.append_value('CFLAGS', '-g -DDEBUG'.split()) # -DGEANY_DISABLE_DEPRECATED

    # summary
    Logs.pprint('BLUE', 'Summary:')
    conf.msg('Install Geany Plugins ' + VERSION + ' in', conf.env['G_PREFIX'])
    conf.msg('Using GTK version', gtk_version)
    conf.msg('Using Geany version', geany_version)
    if svn_rev > 0:
        conf.msg('Compiling Subversion revision', svn_rev)
    conf.msg('Plugins to compile', ' '.join(enabled_plugins))


def configure_plugins(conf, enabled_plugins):
    # we need to iterate over the plugin directories ourselves to be able
    # to catch plugin ConfigurationError's and remove the plugin in this case
    plugins = list(enabled_plugins)
    # iterate over a copy of the list as we remove items during iteration
    for plugin in plugins:
        try:
            # this calls the configure() functions of each plugin's wscript
            conf.recurse(plugin, mandatory=False)
        except ConfigurationError:
            enabled_plugins.remove(plugin)


def setup_configuration_env(conf):
    # Windows specials
    if target_is_win32(conf):
        if conf.env['PREFIX'].lower() == tempfile.gettempdir().lower():
            # overwrite default prefix on Windows (tempfile.gettempdir() is the Waf default)
            new_prefix = os.path.join(str(conf.root), '%s-%s' % (APPNAME, VERSION))
            add_to_env_and_define(conf, 'PREFIX', new_prefix, quote=True)
        conf.env['G_PREFIX'] = conf.env['PREFIX']
        # paths
        add_to_env_and_define(conf, 'PREFIX', '', quote=True)
        add_to_env_and_define(conf, 'LIBDIR', '', quote=True)
        add_to_env_and_define(conf, 'LIBEXECDIR', '', quote=True)
        add_to_env_and_define(conf, 'DOCDIR', 'doc', quote=True)
        conf.define('LOCALEDIR', 'share/locale', 1)
        # overwrite LOCALEDIR to install message catalogues properly
        conf.env['LOCALEDIR'] = os.path.join(conf.env['G_PREFIX'], 'share/locale')
        # DATADIR is defined in objidl.h, so we remove it from config.h
        conf.undefine('DATADIR')
        add_to_env_and_define(conf, 'GEANYPLUGINS_DATADIR', 'share')
    else:
        prefix = conf.env['PREFIX']
        conf.env['G_PREFIX'] = conf.env['PREFIX']
        # DATADIR and LOCALEDIR are defined by the intltool tool
        # but they are not added to the environment, so we need to
        add_define_to_env(conf, 'DATADIR')
        add_define_to_env(conf, 'LOCALEDIR')
        conf.env['cshlib_PATTERN'] = '%s.so'
        doc_dir = '%s/doc/geany-plugins' % conf.env['DATADIR']
        conf.define('PREFIX', prefix, quote=True)
        add_to_env_and_define(conf, 'DOCDIR', doc_dir, quote=True)
        add_to_env_and_define(conf, 'GEANYPLUGINS_DATADIR', conf.env['DATADIR'], quote=True)
        conf.env['GEANYPLUGINS_DATADIR'] = conf.env['DATADIR']
    # common
    pkgdatadir = '%s/%s' % (conf.env['GEANYPLUGINS_DATADIR'], 'geany-plugins')
    pkglibdir = '%s/%s' % (conf.env['LIBDIR'], 'geany-plugins')
    pkgincludedir = '%s/%s' % (conf.env['G_PREFIX'], 'include')
    add_to_env_and_define(conf, 'INCLUDEDIR', pkgincludedir, quote=True)
    add_to_env_and_define(conf, 'DATAROOTDIR', conf.env['GEANYPLUGINS_DATADIR'], quote=True)
    add_to_env_and_define(conf, 'PKGDATADIR', pkgdatadir, quote=True)
    add_to_env_and_define(conf, 'PKGLIBDIR', pkglibdir, quote=True)
    add_to_env_and_define(conf, 'VERSION', VERSION, quote=True)
    add_to_env_and_define(conf, 'PACKAGE', APPNAME, quote=True)
    add_to_env_and_define(conf, 'GETTEXT_PACKAGE', APPNAME, quote=True)
    add_to_env_and_define(conf, 'ENABLE_NLS', 1)

    conf.env.append_value('CFLAGS', ['-DHAVE_CONFIG_H'])


def options(opt):
    opt.tool_options('compiler_cc')
    opt.tool_options('intltool')

    plugins = get_plugins()

    # execute plugin specific option code
    opt.recurse(plugins, mandatory=False)

    # Paths
    opt.add_option('--libdir', type='string', default='',
        help='object code libraries', dest='libdir')
    opt.add_option('--libexecdir', type='string', default='',
        help='program executables', dest='libexecdir')
    # Actions
    opt.add_option('--list-plugins', action='store_true', default=False,
        help='list plugins which can be built', dest='list_plugins')

    opt.add_option('--enable-plugins', action='store', default='',
        help='plugins to be built [plugins in CSV format, e.g. "%(1)s,%(2)s"]' % \
        { '1' : plugins[0], '2' : plugins[1] }, dest='enable_plugins')
    opt.add_option('--skip-plugins', action='store', default='',
        help='plugins which should not be built, ignored when --enable-plugins is set, same format as --enable-plugins',
        dest='skip_plugins')


def build(bld):
    is_win32 = target_is_win32(bld)
    enabled_plugins = bld.env['enabled_plugins']

    if bld.cmd == 'clean':
        remove_linguas_file()
    if bld.cmd in ('install', 'uninstall'):
        bld.add_post_fun(_post_install)

    if bld.env['INTLTOOL']:
        install_path = '${G_PREFIX}/share/locale' if is_win32 else '${LOCALEDIR}'
        bld.new_task_gen(
            features     = ['linguas', 'intltool_po'],
            podir        = 'po',
            appname      = APPNAME,
            install_path = install_path)

    # install additional docs
    install_docs(bld, '', ('README', 'NEWS'))
    if is_win32:
        bld.install_as('${G_PREFIX}/ReadMe.Windows.txt', 'README.windows')

    # execute plugin specific build code
    bld.recurse(enabled_plugins)


def _post_install(ctx):
    is_win32 = target_is_win32(ctx)
    if is_win32:
        return
    theme_dir = Utils.subst_vars('${DATADIR}/icons/hicolor', ctx.env)
    icon_cache_updated = False
    if not ctx.options.destdir:
        ctx.exec_command('gtk-update-icon-cache -q -f -t %s' % theme_dir)
        Logs.pprint('GREEN', 'GTK icon cache updated.')
        icon_cache_updated = True
    if not icon_cache_updated:
        Logs.pprint('YELLOW', 'Icon cache not updated. After install, run this:')
        Logs.pprint('YELLOW', 'gtk-update-icon-cache -q -f -t %s' % theme_dir)


def init(ctx):
    if ctx.options.list_plugins:
        listplugins(ctx)


def listplugins(ctx):
    """list plugins which can be built"""
    plugins = get_plugins()
    Logs.pprint('GREEN', 'The following targets can be chosen with the --enable-plugins option:')
    Logs.pprint('NORMAL', ' '.join(plugins))

    Logs.pprint('GREEN', \
    '\nTo compile only "%(1)s" and "%(2)s", use "./waf configure --enable-plugins=%(1)s,%(2)s".' % \
            { '1' : plugins[0], '2' : plugins[1] } )
    exit(0)


def distclean(ctx):
    Scripting.distclean(ctx)
    remove_linguas_file()


def remove_linguas_file():
    # remove LINGUAS file as well
    try:
        os.unlink(LINGUAS_FILE)
    except OSError:
        pass


@feature('linguas')
def write_linguas_file(self):
    if os.path.exists(LINGUAS_FILE):
        return
    linguas = ''
    if 'LINGUAS' in self.env:
        files = self.env['LINGUAS']
        for po_filename in files.split(' '):
            if os.path.exists ('po/%s.po' % po_filename):
                linguas += '%s ' % po_filename
    else:
        files = os.listdir('%s/po' % self.path.abspath())
        files.sort()
        for filename in files:
            if filename.endswith('.po'):
                linguas += '%s ' % filename[:-3]
    file_h = open(LINGUAS_FILE, 'w')
    file_h.write('# This file is autogenerated. Do not edit.\n%s\n' % linguas)
    file_h.close()


def create_installer(ctx):
    """create the Windows installer (maintainer and Win32 only)"""
    # must be called *after* everything has been installed
    do_sign = os.path.exists('sign.bat') # private file to sign the binary files, not needed
    def sign_binary(filename):
        if do_sign:
            ctx.exec_command('sign.bat %s' % filename)

    # strip all binaries
    Logs.pprint('CYAN', 'Stripping %sfiles' % ('and signing binary ' if do_sign else ''))
    install_dir = '%s-%s' % (APPNAME, VERSION) # should be ctx.env['G_PREFIX']
    files = glob(os.path.join(install_dir, 'lib', '*.dll'))
    files.append(os.path.join(install_dir, 'lib\geany-plugins\geanylua\libgeanylua.dll'))
    for filename in files: # sign the DLL files
        ctx.exec_command('strip %s' % filename)
        sign_binary(filename)
    # create the installer
    launch(ctx, 'makensis /V2 /NOCD build/geany-plugins.nsi', 'Creating the installer', 'CYAN')
    sign_binary('geany-plugins-%s_setup.exe' % VERSION)

=== debian/control ===
Source: geany-plugins
Section: devel
Priority: optional
Maintainer: Geany Packaging Team <pkg-geany-team@lists.alioth.debian.org>
Uploaders: Chow Loong Jin <hyperair@debian.org>, Evgeni Golov <evgeni@debian.org>
Build-Depends: debhelper (>= 9),
               dpkg-dev (>= 1.16.1~),
               dh-autoreconf (>= 4),
               autotools-dev,
               intltool (>= 0.35),
               geany (>= 1.23),
               libgtk2.0-dev (>= 2.16),
               libglib2.0-dev (>= 2.18),
               libenchant-dev (>= 1.3),
               libgtkspell-dev,
               liblua5.1-dev,
               libctpl-dev (>= 0.3),
               python-docutils,
               libxml2-dev (>= 2.6.27),
               libsoup2.4-dev (>= 2.4.0),
               libwebkitgtk-dev (>= 1.1.18) | libwebkit-dev (>= 1.1.18),
               libgdk-pixbuf2.0-dev (>= 2.0),
               libgpgme11-dev,
               libvte-dev (>= 1:0.24),
               libwnck-dev (>= 2.10.0),
               libgconf2-dev (>= 2.6.0),
               libmarkdown2-dev,
               valac (>= 0.7.0)
Standards-Version: 3.9.4
Homepage: http://plugins.geany.org
Vcs-Git: git://git.debian.org/git/pkg-geany/packages/geany-plugins.git
Vcs-Browser: http://git.debian.org/?p=pkg-geany/packages/geany-plugins.git

Package: geany-plugins
Architecture: all
Enhances: geany
Depends: geany-plugin-addons (>= ${source:Version}),
         geany-plugin-codenav (>= ${source:Version}),
         geany-plugin-debugger (>= ${source:Version}),
         geany-plugin-devhelp (>= ${source:Version}),
         geany-plugin-doc (>= ${source:Version}),
         geany-plugin-extrasel (>= ${source:Version}),
         geany-plugin-gendoc (>= ${source:Version}),
         geany-plugin-geniuspaste (>= ${source:Version}),
         geany-plugin-gproject (>= ${source:Version}),
         geany-plugin-insertnum (>= ${source:Version}),
         geany-plugin-latex (>= ${source:Version}),
         geany-plugin-lipsum (>= ${source:Version}),
         geany-plugin-lua (>= ${source:Version}),
         geany-plugin-macro (>= ${source:Version}),
         geany-plugin-miniscript (>= ${source:Version}),
         geany-plugin-multiterm (>= ${source:Version}),
         geany-plugin-numberedbookmarks (>= ${source:Version}),
         geany-plugin-pg (>= ${source:Version}),
         geany-plugin-prj (>= ${source:Version}),
         geany-plugin-sendmail (>= ${source:Version}),
         geany-plugin-tableconvert (>= ${source:Version}),
         geany-plugin-vc (>= ${source:Version}),
         geany-plugin-prettyprinter (>= ${source:Version}),
         geany-plugin-shiftcolumn (>= ${source:Version}),
         geany-plugin-spellcheck (>= ${source:Version}),
         geany-plugin-treebrowser (>= ${source:Version}),
         geany-plugin-updatechecker (>= ${source:Version}),
         geany-plugin-webhelper (>= ${source:Version}),
         geany-plugin-xmlsnippets (>= ${source:Version}),
         ${misc:Depends}
Description: set of plugins for Geany
 This is a metapackage which installs the whole set of plugins for Geany.
 .
 Geany is a fast and lightweight IDE.

Package: geany-plugins-common
Architecture: all
Depends: geany (>= ${geany:Version}),
         ${misc:Depends}
Breaks: geany-plugin-addons (<< 0.19),
        geany-plugin-doc (<< 0.19),
        geany-plugin-gdb (<< 0.19),
        geany-plugin-latex (<< 0.19),
        geany-plugin-lipsum (<< 0.19),
        geany-plugin-lua (<< 0.19),
        geany-plugin-prj (<< 0.19),
        geany-plugin-sendmail (<< 0.19),
        geany-plugin-vc (<< 0.19),
        geany-plugin-shiftcolumn (<< 0.19),
        geany-plugin-spellcheck (<< 0.19)
Description: set of plugins for Geany (translations)
 This package contains translations for the Geany Plugins. You probably do not
 want to install this package directly, but instead install one of the other
 plugins packages.

Package: geany-plugin-addons
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: miscellanous plugins for Geany
 This plugin adds various small addons to Geany which aren't worth an
 individual plugin, but might still be useful for people.
  * DocList: This addon places a new item in the toolbar and when clicked
    offers a menu listing all open files plus the 'Close All' and 'Close Other
    Documents' menu items. This can be useful to quickly access open files and
    switch to them.
  * OpenURI: Adds 'Open URI' and 'Copy URI' menu items to the editor menu when
    the word under the cursor looks like a URI. 'Open URI' uses the browser
    command configured in Geany to open it.
  * Tasks: The tasks plugin goes through a file being edited and picks out
    lines with "TODO" or "FIXME" in them. It collects the text after those words
    and putsthem in a new "Tasks" tab in the message window. Clicking on a task
    in thattab takes you to the line in the file where the task was defined.
  * Systray: Adds a status icon to the notification area (systray) and
    providesa simple popup menu with some basic actions. It can also be used
    to quickly show and hide the Geany main window.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-codenav
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: code navigation plugin for Geany
 This plugin adds some facilities for navigating in code using Geany, making it
 possible to:
  * Switch between header and implementation
  * Go to a file by typing its name
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-commander
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: command panel plugin for Geany
 This plugin adds a command panel to Geany for rapid access to any action.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-debugger
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: debugger plugin for Geany
 Features:
  * Debugger panel
  * Setting target, environment variables and command line arguments
  * Breakpoints
  * Watches, autos
  * Debug terminal
  * Debugger messages window
  * Variables calltips while debugging
  * Saving debug session data in a Geany project (can be switched through
    settings)
  * Double or single panel modes
  * Hotkeys
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-devhelp
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: DevHelp plugin for Geany
 This plugin embeds an API documentation browser and search functionality
 directly into Geany's user interface.
 .
 Devhelp is an API documentation browser mainly aimed at GNOME-related
 libraries, although there are Devhelp books for a wide range of library
 APIs. Check your package manager and/or Google and you should have no trouble
 finding books that can be viewed with Devhelp.
 .
 Geany is a small and lightweight integrated development environment using the
 GTK+ toolkit.

Package: geany-plugin-doc
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: documentation plugin for Geany
 Geanydoc is a plugin for the Geany IDE which is intended to be used to search
 for documentation API from different sources. It allows execution of specified
 commands on the current word at the cursor position or otherwise specified via
 a dialog to obtain this documentation. This documentation is displayed in the
 geany buffer as a tab called *DOC*, or may be displayed in an external program.
 .
 After installing this package, you'll need to enable the "Doc" plugin
 and then setup a keyword binding for it in Geany's preferences dialogue.
 .
 Geany is a small and lightweight integrated development environment using the
 GTK+ toolkit.

Package: geany-plugin-extrasel
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: extra selection plugin for Geany
 The Extra Selection plugin adds the following functions to Geany:-
  * Go to matching brace and select (select to matching brace)
  * Go to line and select (select to line)
  * Ctrl+Shift+Alt+Left/Right/Home/End key - same as Ctrl+Shift, but for
    rectangular selection.
  * Column mode - while active, all (Ctrl)-Shift-Arrow keys do rectangle
    selection instead of stream.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-gendoc
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: documentation generation plugin for Geany
 GeanyGenDoc is a plugin for Geany which provides support for automatically
 generating documentation based on comments in the source code.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-geniuspaste
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: GeniusPaste plugin for Geany
 This plugin allows the user to paste the code from Geany into five different
 pastebins. At the moment it supports this services:
  - codepad.org
  - tinypaste.com
  - pastebin.geany.org
  - dpaste.de
  - sprunge.us
 .
 GeniusPaste detects automatically the syntax of the code and paste it with
 syntax highlighting enabled. It can also display the pasted code opening a new
 browser tab.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-gproject
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: gproject plugin for Geany
 GProject is an extension of Geany's project management displaying a
 tree of files belonging to the project in the sidebar. In addition, it
 enables quick swapping between header and source files, searching
 project files by name and more.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-insertnum
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: number inserting plugin for Geany
 This plugin for Geany replaces a (possibly zero-width) rectangular selection
 with integer numbers, using start/step/base etc. specified by the user. For
 practical reasons, the number of lines is limited to 500000.
 .
 Geany is a small and lightweight integrated development environment using the
 Gtk+ toolkit.

Package: geany-plugin-latex
Enhances: geany
Architecture: any
Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
         ${shlibs:Depends}, ${misc:Depends}
Description: improved LaTeX support plugin for Geany
 GeanyLaTeX is a plugin for the Geany IDE to improve work with LaTeX. Features
 include:
  * Wizard for creating a new LaTeX-document
  * Frontend for easy input of \ref{} and \label{}
  * Easy adding of special characters and environments through plugin menu entry
  * Support for adding new items to BibTeX database
  * Toolbar with commonly used format options

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/buildflags.mk

export LDFLAGS += -Wl,--as-needed -Wl,-z,defs

GEANY_VERSION = $(shell pkg-config --modversion geany)
GEANY_ABI = geany-abi-$(shell grep 'define GEANY_ABI_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')
GEANY_API = geany-api-$(shell grep 'define GEANY_API_VERSION' /usr/include/geany/plugindata.h | awk '{print $$3}')

override_dh_autoreconf:
	dh_autoreconf --as-needed

# specify libexecdir to avoid cascading geany-plugins directories in /usr/lib
override_dh_auto_configure:
	dh_auto_configure --				\
		--libexecdir='$${exec_prefix}/lib'	\
		--enable-addons				\
		--enable-codenav			\
		--enable-commander			\
		--enable-debugger			\
		--enable-devhelp			\
		--enable-geanydoc			\
		--enable-geanyextrasel			\
		--enable-geanygendoc			\
		--enable-geanyinsertnum			\
		--enable-geanylatex			\
		--enable-geanylipsum			\
		--enable-geanylua			\
		--enable-geanymacro			\
		--enable-geanyminiscript		\
		--enable-geanynumberedbookmarks		\
		--enable-geanyprj			\
		--enable-geanysendmail			\
		--enable-geanyvc			\
		--enable-gtkspell			\
		--enable-geanypg			\
		--enable-largefile			\
		--enable-geniuspaste			\
		--enable-gproject			\
		--enable-markdown			\
		--enable-multiterm			\
		--enable-pretty_printer			\
		--enable-scope				\
		--enable-shiftcolumn			\
		--enable-spellcheck			\
		--enable-treebrowser			\
		--enable-tableconvert			\
		--enable-updatechecker			\
		--enable-webhelper			\
		--enable-xmlsnippets

# install separate ChangeLogs for each different plugin
override_dh_installchangelogs:
	for changelog in */ChangeLog; do \
		[ ! -s $$changelog ] && continue; \
		if [ $$changelog = po/ChangeLog ]; then \
			pkg=geany-plugins-common; \
		else \
			pkg=geany-plugin-$$(dirname $$changelog | sed -e's/^geany//'); \
		fi; \
		dh_installchangelogs \
			-p$$pkg \
			$$changelog; \
	done
	dh_installchangelogs

# add geany:Version substvar to debian/*.substvars
override_dh_gencontrol:
	dh_gencontrol -- \
		"-Vgeany:Version=$(GEANY_VERSION)" \
		"-Vgeany:API=$(GEANY_API)" \
		"-Vgeany:ABI=$(GEANY_ABI)"

# Don't make shlibs (false positive on pretty-printer.so
override_dh_makeshlibs:

override_dh_install:
	dh_install --list-missing

%:
	dh $@ --with=autoreconf --parallel

upstream_version ?= $(shell dpkg-parsechangelog | sed -rne 's/^Version: ([0-9.]+)(\+dfsg)?.*$$/\1/p')
dfsg_version = $(upstream_version)+dfsg
pkg = $(shell dpkg-parsechangelog | sed -ne 's/^Source: //p')

get-orig-source:
	uscan --noconf --force-download --rename --repack --download-current-version --destdir=.
	tar -xzf $(pkg)_$(upstream_version).orig.tar.gz
	mv $(pkg)-$(upstream_version) $(pkg)-$(dfsg_version)
	rm $(pkg)-$(dfsg_version)/waf
	GZIP="-9fn --rsyncable" tar -czf $(pkg)_$(dfsg_version).orig.tar.gz $(pkg)-$(dfsg_version)
	rm -rf $(pkg)-$(dfsg_version)

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\+dfsg(\.\d+)?$// \
http://plugins.geany.org/geany-plugins/geany-plugins-(.*).tar.gz

## geany-plugins 1.24+dfsg

=== wscript ===
--- 
+++ 
@@ -39,18 +39,18 @@
 
 import os
 import tempfile
-from glob import glob
 from waflib import Logs, Scripting, Utils
 from waflib.Tools import c_preproc
 from waflib.Errors import ConfigurationError
 from waflib.TaskGen import feature
+from waflib.Tools.compiler_c import c_compiler
 from build.wafutils import (
     add_define_to_env,
     add_to_env_and_define,
     check_cfg_cached,
     get_plugins,
     get_enabled_plugins,
-    get_svn_rev,
+    get_git_rev,
     install_docs,
     launch,
     load_intltool_if_available,
@@ -60,7 +60,7 @@
 
 
 APPNAME = 'geany-plugins'
-VERSION = '1.23'
+VERSION = '1.24'
 LINGUAS_FILE = 'po/LINGUAS'
 
 top = '.'
@@ -87,44 +87,44 @@
                    args='--cflags --libs')
     check_cfg_cached(conf,
                    package='geany',
-                   atleast_version='1.23',
+                   atleast_version='1.24',
                    uselib_store='GEANY',
                    mandatory=True,
                    args='--cflags --libs')
 
     set_lib_dir(conf)
-    # SVN/GIT detection
-    svn_rev = get_svn_rev(conf)
-    conf.define('REVISION', svn_rev, 1)
+    # GIT detection
+    revision = get_git_rev(conf)
+    conf.define('REVISION', revision, 1)
     # GTK/Geany versions
     geany_version = conf.check_cfg(modversion='geany') or 'Unknown'
     gtk_version = conf.check_cfg(modversion='gtk+-2.0') or 'Unknown'
 
     load_intltool_if_available(conf)
+    setup_configuration_env(conf)
 
     # build plugin list
     enabled_plugins = get_enabled_plugins(conf)
 
-    # execute plugin specific coniguration code
+    # execute plugin specific configuration code
     configure_plugins(conf, enabled_plugins)
     # now add the enabled_plugins to the env to remember them
     conf.env.append_value('enabled_plugins', enabled_plugins)
 
-    setup_configuration_env(conf)
     setup_makefile(conf)
     conf.write_config_header('config.h')
 
     # enable debug when compiling from VCS
-    if svn_rev > 0:
-        conf.env.append_value('CFLAGS', '-g -DDEBUG'.split()) # -DGEANY_DISABLE_DEPRECATED
+    if revision > 0:
+        conf.env.append_value('CFLAGS', '-g -DDEBUG'.split())  # -DGEANY_DISABLE_DEPRECATED
 
     # summary
     Logs.pprint('BLUE', 'Summary:')
     conf.msg('Install Geany Plugins ' + VERSION + ' in', conf.env['G_PREFIX'])
     conf.msg('Using GTK version', gtk_version)
     conf.msg('Using Geany version', geany_version)
-    if svn_rev > 0:
-        conf.msg('Compiling Subversion revision', svn_rev)
+    if revision > 0:
+        conf.msg('Compiling Git revision', revision)
     conf.msg('Plugins to compile', ' '.join(enabled_plugins))
 
 
@@ -190,6 +190,10 @@
 
 
 def options(opt):
+    # Disable MSVC detetion on win32: building Geany-Plugins with MSVC is currently not supported
+    # If anyone wants to add support for building with MSVC, this hack should be removed.
+    c_compiler['win32'] = ['gcc']
+
     opt.tool_options('compiler_cc')
     opt.tool_options('intltool')
 
@@ -198,6 +202,9 @@
     # execute plugin specific option code
     opt.recurse(plugins, mandatory=False)
 
+    # Options
+    opt.add_option('--no-scm', action='store_true', default=False,
+        help='Disable SCM detection [default: No]', dest='no_scm')
     # Paths
     opt.add_option('--libdir', type='string', default='',
         help='object code libraries', dest='libdir')
@@ -208,8 +215,8 @@
         help='list plugins which can be built', dest='list_plugins')
 
     opt.add_option('--enable-plugins', action='store', default='',
-        help='plugins to be built [plugins in CSV format, e.g. "%(1)s,%(2)s"]' % \
-        { '1' : plugins[0], '2' : plugins[1] }, dest='enable_plugins')
+        help='plugins to be built [plugins in CSV format, e.g. "%(1)s,%(2)s"]' %
+        {'1': plugins[0], '2': plugins[1]}, dest='enable_plugins')
     opt.add_option('--skip-plugins', action='store', default='',
         help='plugins which should not be built, ignored when --enable-plugins is set, same format as --enable-plugins',
         dest='skip_plugins')
@@ -267,9 +274,9 @@
     Logs.pprint('GREEN', 'The following targets can be chosen with the --enable-plugins option:')
     Logs.pprint('NORMAL', ' '.join(plugins))
 
-    Logs.pprint('GREEN', \
-    '\nTo compile only "%(1)s" and "%(2)s", use "./waf configure --enable-plugins=%(1)s,%(2)s".' % \
-            { '1' : plugins[0], '2' : plugins[1] } )
+    Logs.pprint('GREEN',
+    '\nTo compile only "%(1)s" and "%(2)s", use "./waf configure --enable-plugins=%(1)s,%(2)s".' %
+            {'1': plugins[0], '2': plugins[1]})
     exit(0)
 
 
@@ -294,7 +301,7 @@
     if 'LINGUAS' in self.env:
         files = self.env['LINGUAS']
         for po_filename in files.split(' '):
-            if os.path.exists ('po/%s.po' % po_filename):
+            if os.path.exists('po/%s.po' % po_filename):
                 linguas += '%s ' % po_filename
     else:
         files = os.listdir('%s/po' % self.path.abspath())
@@ -307,24 +314,19 @@
     file_h.close()
 
 
-def create_installer(ctx):
-    """create the Windows installer (maintainer and Win32 only)"""
-    # must be called *after* everything has been installed
-    do_sign = os.path.exists('sign.bat') # private file to sign the binary files, not needed
-    def sign_binary(filename):
-        if do_sign:
-            ctx.exec_command('sign.bat %s' % filename)
-
-    # strip all binaries
-    Logs.pprint('CYAN', 'Stripping %sfiles' % ('and signing binary ' if do_sign else ''))
-    install_dir = '%s-%s' % (APPNAME, VERSION) # should be ctx.env['G_PREFIX']
-    files = glob(os.path.join(install_dir, 'lib', '*.dll'))
-    files.append(os.path.join(install_dir, 'lib\geany-plugins\geanylua\libgeanylua.dll'))
-    for filename in files: # sign the DLL files
-        ctx.exec_command('strip %s' % filename)
-        sign_binary(filename)
-    # create the installer
-    launch(ctx, 'makensis /V2 /NOCD build/geany-plugins.nsi', 'Creating the installer', 'CYAN')
-    sign_binary('geany-plugins-%s_setup.exe' % VERSION)
-
-
+def updatepo(ctx):
+    """update the message catalogs for internationalization"""
+    potfile = '%s.pot' % APPNAME
+    os.chdir('%s/po' % top)
+    try:
+        try:
+            old_size = os.stat(potfile).st_size
+        except OSError:
+            old_size = 0
+        ctx.exec_command('intltool-update --pot -g %s' % APPNAME)
+        size_new = os.stat(potfile).st_size
+        if size_new != old_size:
+            Logs.pprint('CYAN', 'Updated POT file.')
+            launch(ctx, 'intltool-update -r -g %s' % APPNAME, 'Updating translations', 'CYAN')
+        else:
+            Logs.pprint('CYAN', 'POT file is up to date.')

=== debian/changelog ===
geany-plugins (1.24+dfsg-2) unstable; urgency=medium

  [ Chow Loong Jin ]
  * [6e4e828] Add --enable flags for new plugins

  [ Evgeni Golov ]
  * [431a28d] add python-gtk2-dev B-D, needed for geanypy
  * [f2dc92e] add package definitions for the new plugins
  * [10567a7] properly link geanypy against gmodule, patch by upstream
  * [de7dfab] add the new plugins to debian/copyright
  * [988f71a] use canonical git urls
  * [c1e261c] Standards-Version: 3.9.5
  * [6fa8471] it's Perl and Python, not perl and python
  * [a0558cb] remove unused lintian overrides
  * [88ee768] fix compilation on GNU/Hurd

 -- Chow Loong Jin <hyperair@debian.org>  Tue, 22 Apr 2014 18:55:08 +0200

geany-plugins (1.24+dfsg-1) unstable; urgency=medium

  [ Evgeni Golov ]
  * [0aa0db1] add signature check for downloads
  * [f152c29] Imported Upstream version 1.24+dfsg
  * [4e0e7f4] we need gean 1.24 to build geany-plugins 1.24

  [ Chow Loong Jin ]
  * [ccfcba3] Use small compiled program to dump GEANY_ABI and GEANY_API.
    Geany 1.24.1 contains a GEANY_ABI that isn't just a simple integer -- it's an
    expression that needs to be resolved now.

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 20 Apr 2014 01:34:06 +0800

=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
                dh-autoreconf (>= 4),
                autotools-dev,
                intltool (>= 0.35),
-               geany (>= 1.23),
+               geany (>= 1.24),
                libgtk2.0-dev (>= 2.16),
                libglib2.0-dev (>= 2.18),
                libenchant-dev (>= 1.3),
@@ -25,18 +25,21 @@
                libwnck-dev (>= 2.10.0),
                libgconf2-dev (>= 2.6.0),
                libmarkdown2-dev,
+               python-gtk2-dev,
                valac (>= 0.7.0)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Homepage: http://plugins.geany.org
-Vcs-Git: git://git.debian.org/git/pkg-geany/packages/geany-plugins.git
-Vcs-Browser: http://git.debian.org/?p=pkg-geany/packages/geany-plugins.git
+Vcs-Git: git://anonscm.debian.org/pkg-geany/packages/geany-plugins.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-geany/packages/geany-plugins.git
 
 Package: geany-plugins
 Architecture: all
 Enhances: geany
 Depends: geany-plugin-addons (>= ${source:Version}),
+         geany-plugin-autoclose (>= ${source:Version}),
          geany-plugin-codenav (>= ${source:Version}),
          geany-plugin-debugger (>= ${source:Version}),
+         geany-plugin-defineformat (>= ${source:Version}),
          geany-plugin-devhelp (>= ${source:Version}),
          geany-plugin-doc (>= ${source:Version}),
          geany-plugin-extrasel (>= ${source:Version}),
@@ -51,8 +54,11 @@
          geany-plugin-miniscript (>= ${source:Version}),
          geany-plugin-multiterm (>= ${source:Version}),
          geany-plugin-numberedbookmarks (>= ${source:Version}),
+         geany-plugin-pairtaghighlighter (>= ${source:Version}),
          geany-plugin-pg (>= ${source:Version}),
+         geany-plugin-pohelper (>= ${source:Version}),
          geany-plugin-prj (>= ${source:Version}),
+         geany-plugin-py (>= ${source:Version}),
          geany-plugin-sendmail (>= ${source:Version}),
          geany-plugin-tableconvert (>= ${source:Version}),
          geany-plugin-vc (>= ${source:Version}),
@@ -115,6 +121,41 @@
  Geany is a small and lightweight integrated development environment using the
  Gtk+ toolkit.
 
+Package: geany-plugin-autoclose
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
+         ${shlibs:Depends}, ${misc:Depends}
+Description: auto-closing plugin for Geany
+ This plugin enables auto-closing features. Auto-closing works while you typing
+ and intellectually helps you to write code.
+ .
+ Features:
+  * auto-close for: { }, [ ], ( ), " ", ' ', < >, ` `
+  * customizeable auto-closing inside strings and comments
+  * delete pairing character if you pressed BackSpace
+  * suppress inserting one char twice (if you type "{}" you will get "{}", not
+    "{}}")
+  * enclose selected text into brackets instead of removing selection (select
+    text and type "(" or ")" to enclose selection into "()")
+  * keep selection when enclosing
+  * for C-like languages enclosing selection into "{}" makes auto-indentation
+    (select text and type "{" or "}" - text will be enclosed and indented)
+  * enclosing in {} moves cursor to beginning (before "{" character)
+  * for C-like languages to insert {}-block you do not need to select text
+    precisely: plugin detects boundaries automatically, just ensure that
+    selection covers lines you need to indent (works like TAB indentation)
+  * fix auto-indent inside {} (makes full indent for this block)
+  * auto-close curly bracket by pressing Enter
+  * auto-close functions (``"sin(|" -> "sin(|);"``) with doubling suppression
+    (for C/C++ languages only)
+  * remove paring brace when pressing Shift+BackSpace, unindent {}-blocks
+  * add semicolon after ``struct {|};`` and ``class {|};``
+  * move cursor to closed char by pressing Tab
+ .
+ Geany is a small and lightweight integrated development environment using the
+ Gtk+ toolkit.
+
 Package: geany-plugin-codenav
 Enhances: geany
 Architecture: any
@@ -162,6 +203,17 @@
  Geany is a small and lightweight integrated development environment using the
  Gtk+ toolkit.
 
+Package: geany-plugin-defineformat
+Enhances: geany
+Architecture: any
+Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
+         ${shlibs:Depends}, ${misc:Depends}
+Description: on-the-fly #define prettyprinter plugin for Geany
+ This plugin will help you to write multiline defines with aligned backslash.
+ .
+ Geany is a small and lightweight integrated development environment using the
+ Gtk+ toolkit.
+
 Package: geany-plugin-devhelp
 Enhances: geany
 Architecture: any
@@ -223,67 +275,3 @@
  GeanyGenDoc is a plugin for Geany which provides support for automatically
  generating documentation based on comments in the source code.
  .
- Geany is a small and lightweight integrated development environment using the
- Gtk+ toolkit.
-
-Package: geany-plugin-geniuspaste
-Enhances: geany
-Architecture: any
-Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
-         ${shlibs:Depends}, ${misc:Depends}
-Description: GeniusPaste plugin for Geany
- This plugin allows the user to paste the code from Geany into five different
- pastebins. At the moment it supports this services:
-  - codepad.org
-  - tinypaste.com
-  - pastebin.geany.org
-  - dpaste.de
-  - sprunge.us
- .
- GeniusPaste detects automatically the syntax of the code and paste it with
- syntax highlighting enabled. It can also display the pasted code opening a new
- browser tab.
- .
- Geany is a small and lightweight integrated development environment using the
- Gtk+ toolkit.
-
-Package: geany-plugin-gproject
-Enhances: geany
-Architecture: any
-Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
-         ${shlibs:Depends}, ${misc:Depends}
-Description: gproject plugin for Geany
- GProject is an extension of Geany's project management displaying a
- tree of files belonging to the project in the sidebar. In addition, it
- enables quick swapping between header and source files, searching
- project files by name and more.
- .
- Geany is a small and lightweight integrated development environment using the
- Gtk+ toolkit.
-
-Package: geany-plugin-insertnum
-Enhances: geany
-Architecture: any
-Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
-         ${shlibs:Depends}, ${misc:Depends}
-Description: number inserting plugin for Geany
- This plugin for Geany replaces a (possibly zero-width) rectangular selection
- with integer numbers, using start/step/base etc. specified by the user. For
- practical reasons, the number of lines is limited to 500000.
- .
- Geany is a small and lightweight integrated development environment using the
- Gtk+ toolkit.
-
-Package: geany-plugin-latex
-Enhances: geany
-Architecture: any
-Depends: ${geany:ABI}, geany-plugins-common (= ${source:Version}),
-         ${shlibs:Depends}, ${misc:Depends}
-Description: improved LaTeX support plugin for Geany
- GeanyLaTeX is a plugin for the Geany IDE to improve work with LaTeX. Features
- include:
-  * Wizard for creating a new LaTeX-document
-  * Frontend for easy input of \ref{} and \label{}
-  * Easy adding of special characters and environments through plugin menu entry
-  * Support for adding new items to BibTeX database
-  * Toolbar with commonly used format options

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=dversionmangle=s/\+dfsg(\.\d+)?$//,pgpsigurlmangle=s/$/.sig/ \
http://plugins.geany.org/geany-plugins/geany-plugins-(.*).tar.gz
